#include <windows.h>
#include <shlobj.h>
#include <assert.h>

BOOL MakeFile(LPCTSTR text)
{
    HANDLE hFile = CreateFile(text, GENERIC_WRITE, FILE_SHARE_READ, NULL,
        CREATE_ALWAYS, 0, NULL);
    CloseHandle(hFile);
    return hFile != INVALID_HANDLE_VALUE;
}

#ifndef INVALID_FILE_ATTRIBUTES
    #define INVALID_FILE_ATTRIBUTES     ((DWORD)-1)
#endif

int main(void)
{
    static const TCHAR file[] = TEXT("a.txt");
    DWORD attrs;

    attrs = GetFileAttributes(file);
    if (attrs == INVALID_FILE_ATTRIBUTES)
        DeleteFile(file);

    MakeFile(file);
    SetFileAttributes(file, FILE_ATTRIBUTE_READONLY);

    attrs = GetFileAttributes(file);
    SetFileAttributes(file, attrs & ~FILE_ATTRIBUTE_READONLY);

    attrs = GetFileAttributes(file);
    assert(!(attrs & FILE_ATTRIBUTE_READONLY));

    return 0;
}
